/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * BPCFG.H
 *
 * PROGRAMMER : Juan M. Alvarado
 *    VERSION : 00.000
 *    CREATED : 04/12/91
 *   MODIFIED : 06/27/91
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Constants for BrushPack.CFG file and for LoadBPI() for 
 *		communicating what processing to do on brushpak data as it
 *		is loaded.
 *
 * HISTORY
 *
*/

#ifndef BPCFG_H
#define BPCFG_H

/**************************** C O N S T A N T S ***************************/

/* BrushPak .CFG file constants for code values that tell LoadBPI()
 * what processing to do on data when it loads it. 
*/
#define DONT_TOUCH			0
#define MAKE_GSHAPE			1
#define MAKE_PAINTBOX		2
#define	MAKE_PALETTE		3
#define MAKE_COLORCYCLESET	4


#endif /* BPCFG_H */

