/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * DATAFILE.H
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 07/25/90
 *   MODIFIED : 09/21/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Routines to Create Intel-Hex format files.
 *
 * HISTORY
 *
*/

#ifndef ECHIDNA_DATAFILE_H
#define ECHIDNA_DATAFILE_H

#include <echidna/platform.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <echidna/etypes.h>
#include <stdio.h>

/**************************** C O N S T A N T S ***************************/

#define	DATAST_NOLINEINFO	0x0001
#define DATAST_ASMLINENO	0x0002

/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern short StartIntelHexSection (FILE *fp, UWORD Addr);
extern short WriteIntelHex (FILE *fp, UBYTE *data, size_t size);
extern int   EndIntelHexSection (FILE *fp);
extern int   EndIntelHexFile (FILE *fp);

extern void	 StartDataStatements (char *header, char *format, char *delimiter, short bytesperline, UWORD flags);
extern short WriteDataStatements (FILE *fp, UBYTE *data, size_t size);
extern short EndDataStatements (FILE *fp);
extern void	 StartDBHEXStatements (void);
extern void	 StartDBDECStatements (void);
extern void	 StartWordStatements (char *header, char *format, char *delimiter, short wordsperlibe, UWORD flags);
extern short WriteWordStatements (FILE *fp, UWORD *data, size_t wordcount);
extern short EndWordStatements (FILE *fp);

extern int	 OpenCPEFileWrite (char *filename);
extern short OpenCPEMemSection (int fh, ULONG address);
extern short WriteCPEMemSection (int fh, void *buffer, ULONG size);
extern short CloseCPEMemSection (void);
extern short WriteEntireCPEMemSection (int fh, ULONG address, void *buffer, ULONG size);
extern short CloseCPEFileWrite (int fh);

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_DATAFILE_H */

