/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * DBuf.H
 *
 * PROGRAMMER : Juan M. Alvarado
 *    VERSION : 00.000
 *    CREATED : 12/14/89
 *   MODIFIED : 11/01/93
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		
 *
 * HISTORY
 *	05/25/91 Saturday (RGM) - Added include for <stddef.h>.
 *
*/
#ifndef ECHIDNA_DBUF_H
#define ECHIDNA_DBUF_H

#include <echidna/platform.h>
#include "switches.h"

#ifdef __cplusplus
extern "C" {
#endif

#include <echidna/graphics.h>

/**************************** C O N S T A N T S ***************************/

/***************************** T Y P E D E F S ****************************/

/****************************** G L O B A L S *****************************/

/******************************* M A C R O S ******************************/

/****************** F U N C T I O N   P R O T O T Y P E S *****************/
#if __NOT_ANSI__		/** Non-ANSI Prototypes **/



#else					/** ANSI Prototypes **/

/** C functions **/

extern void			 GRoutine(DBufPeepGShape) (GShape *shapeptr, short x, short y);
extern void			 GRoutine(DBufStampGShape) (GShape *shapeptr, short x, short y);
extern void			 GRoutine(DBufStampGShapeNoTrans) (GShape *shapeptr, short x, short y);
extern void			 GRoutine(DBufStampClearGShape) (GShape *shapeptr, short x, short y);
extern void			 GRoutine(DBufStampRect) (short x, short y, short w, short h);
extern void			 GRoutine(DBufPeepRect) (short x, short y, short w, short h);
extern void			 GRoutine(DBufFlipScreen) (void);

extern void			 AddDBufStampArea (
						short	x,
						short	y,
						short	width,
						short	height
					 );
extern void			 AddDBufPeepArea (
						short	x,
						short	y,
						short	width,
						short	height
					 );
extern void			 AddDBufUpdateArea (
						short	x,
						short	y,
						short	width,
						short	height
					 );

extern void			 ResetSALists (void);

#if __MSDOS__
	extern short		 OpenDBufGraphics (
							short mode, 
							short max_shapes, 
							size_t max_brush_size,
							short max_palette_colors, 
							short max_cycle_colors, 
							short palette_update_hertz
					 	);
	extern void			 CloseDBufGraphics (void);
#elif __AMIGAOS__
	#define OpenDBufGraphics(m,ms,mbs,mcc,puh)	\
		OpenGraphics (m,mbs,mpc,mcc,puh)
	#define CloseDBufGraphics()
#else
#error ugggghh!
#endif


#endif /** Function Prototypes **/

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_DBUF_H */

