/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * EZPARSE.H
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 03/07/91
 *   MODIFIED : 09/21/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Routines to simply parse a file!?!?!
 *
 * HISTORY
 *
*/

#ifndef ECHIDNA_EZPARSE_H
#define ECHIDNA_EZPARSE_H

#include <echidna\platform.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <echidna\argparse.h>

/**************************** C O N S T A N T S ***************************/

#define MAX_PARSE_LINE	256

#define EZPARSE_OKAY	1
#define	EZPARSE_ERROR	0
#define EZPARSE_FATAL	(-1)

/******************************** T Y P E S *******************************/

typedef short (*ParseFunc) (char **argv, void *userdata);

typedef struct {
	char		*Keyword;
	ArgSpec		*Template;
	ParseFunc	 ParseFunc;
} KeyWord;

/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern void		 EZParseKeepBlankLines (short flag);
extern int		 EZParseLineNo (void);
extern void		 EZParseError (char *fmt, ...);
extern void		 EZParseError1 (char *msg1, char *msg2);
extern short	 EZParseGetLine (FILE *fp, char *linebuff, short maxline, short strip);
extern void		 EZResetParseFilename (char *filename);
extern short	 EZParseFile (
					KeyWord *keywords,
					char *filename,
					short maxargs,
					void *userdata
				 );

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_EZPARSE_H */
