/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * MOUSE.H
 *
 * PROGRAMMER : Juan M. Alvarado
 *    VERSION : 00.000
 *    CREATED : 01/23/92
 *   MODIFIED : 10/12/93
 *       TABS : 04 08
 *
 * DESCRIPTION
 *		Externs for GR12H mouse routines.
 *
 * HISTORY
 *
*/

#ifndef ECHIDNA_MOUSE_H
#define ECHIDNA_MOUSE_H

#include <echidna/platform.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <echidna/timer.h>
#include <echidna/graphics.h>

/**************************** C O N S T A N T S ***************************/

#define MOUSE_LEFTBUTTON	(1U << 0)
#define MOUSE_RIGHTBUTTON	(1U << 1)
#define MOUSE_FIRSTDOWN	(1U << 2)
#define MOUSE_BEFOREEVENT	(1U << 3)
#define MOUSE_AFTEREVENT	(1U << 4)
#define MOUSE_DOUBLE		(1U << 5)	/* used to indicate double click */

/******************************** T Y P E S *******************************/


typedef struct {
	short X;
	short Y;
	USHORT Buttons;
	USHORT OldButtons;
} MouseInfo;


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern short		 OpenMouse (void);
extern void		 CloseMouse (void);
extern void		 ShowMouse (void);
extern void		 HideMouse (void);
extern void		 ReadMouse (MouseInfo *pmi);
extern void		 SetMouseHotSpot (short xhot, short yhot);
extern void		 SetMouseResolution (short xres, short yres);
extern void		 SetMouseRange (short xmin, short xmax, short ymin, short ymax);
extern void		 SetMouseScreenDimensions (short width, short height);
extern void		 SetMouseShape (GShape *shape);
extern void		 SetMousePosition (short x, short y);

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_MOUSE_H */

