/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * RECORDER.H
 *
 * PROGRAMMER : Dan Chang
 *    VERSION : 00.000
 *    CREATED : 09/16/92
 *   MODIFIED : 09/17/92
 *       TABS : 04 07
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Header file for routines to record and restore mouse and keyboard
 *		events from a text file.
 *
 * HISTORY
 *
*/

#ifndef RECORDER_H
#define RECORDER_H

#include <echidna/platform.h>
#include "switches.h"

/**************************** C O N S T A N T S ***************************/

#define fFromUser			0
#define fReadEvents		1
#define fSaveAllEvents	2
#define fSaveSomeEvents	3

#define fReadFast			128

/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern void SetEarlyExitTime(short w);
extern short OpenEventRecorder(char *szFile, short f);
extern void CloseEventRecorder(void);
extern short ReadEvent(char *sz);
extern void SaveEvent(char *sz);

#endif /* RECORDER_H */

