/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * XTRAMEM.H
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 11/04/91
 *   MODIFIED : 10/06/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Public header file for XTRAMEM.C.
 *
 * HISTORY
 *
*/

#ifndef ECHIDNA_XTRAMEM_H
#define ECHIDNA_XTRAMEM_H

#include <echidna/platform.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <echidna/ems.h>
#include <echidna/xms.h>

#include <stddef.h>
/**************************** C O N S T A N T S ***************************/

#define LARGEST_XTRAMEM (60000U)

/* XTRAMemoryType values */

#define	xmtEMS	(1)
#define	xmtXMS	(2)
#define	xmtSTD	(4)

/******************************** T Y P E S *******************************/

typedef UBYTE XMT;	/* XTRAMemoryType */

typedef struct {
	XMT			 xmt;
	void		*Memory;
} MEMPntr;

typedef union {
	EMSPntr		 e;
	XMSPntr		 x;
	MEMPntr		 m;
} XTRAType;

#if (__MSDOS32X__ || __AMIGAOS__ || __MACOS__ || __EGGS_SGI__)
typedef	void *XTRAPntr;
#else
typedef XTRAType *XTRAPntr;
#endif

/****************************** G L O B A L S *****************************/

extern UWORD szNotXTRARAM;

/******************************* M A C R O S ******************************/

#define ActivateXTRA(xp)	ActivateXTRAatWin ((xp), 0)

#define XmtFromPxtr(pxtr)	(((MEMPntr *)(pxtr))->xmt)

/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern void	MinMemFree (void);
extern void	PrintMinMemFree (void);

#if (__MSDOS32X__ || __AMIGAOS__ || __MACOS__ || __EGGS_SGI__)

#include <string.h>

extern	void	*__LastXTRA;

#define SetXTRAMemoryPoolSize(cXTRA)
#define	LastActivateXTRA()			(__LastXTRA)
#define	SetLargestXTRA(size)		
#define	ActivateXTRAatWin(xp,win)	(__LastXTRA = (void *)(xp))
#define	UpdateXTRA(xp)				
#define ReleaseXTRA(xp)				
#define	FreeXTRA					free
#define	AllocXTRA					malloc
#define	AllocXTRAofXMT(size,xmt)	(malloc(size))
#define	ReadXTRA(xp,off,len,mem)	(memcpy((mem),((char *)(xp))+(off),(len)))
#define	WriteXTRA(mem,len,xp,off)	(memcpy(((char *)(xp))+(off),(mem),(len)))
#define	AvailXTRA(xmt)				(12345678L)
#undef  XmtFromPxtr
#define XmtFromPxtr(pxtr)			(xmtSTD)

#elif __MSDOS__

extern void		 SetXTRAMemoryPoolSize(UWORD cXTRAKBytes);
extern XTRAPntr  LastActivateXTRA (void);
extern void		 SetLargestXTRA (size_t size);
extern void	far	*ActivateXTRAatWin (XTRAPntr xp, short window);
extern void		 UpdateXTRA (XTRAPntr xp);
extern void		 ReleaseXTRA (XTRAPntr xp);
extern void		 FreeXTRA (XTRAPntr xp);
extern XTRAPntr	 AllocXTRA (size_t size);
extern XTRAPntr  AllocXTRAofXMT (size_t size, XMT xmt);
extern void		 ReadXTRA (XTRAPntr xp, UWORD uwOffset, UWORD uwLength, void far *pMem);
extern void		 WriteXTRA (void far *pMem, UWORD uwLength, XTRAPntr xp, UWORD uwOffset);
extern long		 AvailXTRA(XMT xmt);

#else
#error Need Macros
#endif

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_XTRAMEM_H */

