/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * PCX.H
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 07/30/92
 *   MODIFIED : 09/21/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		
 *
 * HISTORY
 *
*/

#ifndef PCX_H
#define PCX_H

#include <echidna/platform.h>

#include <echidna/etypes.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <echidna/eio.h>
#include <echidna/emacros.h>
#include <echidna/eerrors.h>
#include <echidna/readiff.h>
#include <echidna/bilbm.h>

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/

typedef struct {
	UBYTE	Manufacturer;
	UBYTE	Version;
	UBYTE	Encoding;
	UBYTE	BitsPerPixel;
	short	XMin;
	short	YMin;
	short	XMax;
	short	YMax;
	short	HDPI;
	short	VDPI;
	UBYTE	Colormap[48];
	UBYTE	reserved0;
	UBYTE	NPlanes;
	short	BytesPerLine;
	short	PaletteInfo;
	short	HScreenSize;
	short	VScreenSize;
	UBYTE	reserved[54];
} PCXHeader;

/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern BOOL IsPCXFile (IFFTracker *iff);
extern BOOL ReadPCX (IFFTracker *iff);

#endif /* PCX_H */

