# 
# The contents of this file are subject to the Mozilla Public 
# License Version 1.1 (the "License"); you may not use this file 
# except in compliance with the License. You may obtain a copy of 
# the License at http://www.mozilla.org/MPL/ 
# 
# Software distributed under the License is distributed on an "AS 
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
# implied. See the License for the specific language governing 
# rights and limitations under the License. 
# 
# The Original Code is tUME: the Universal Map Editor, released 
# June 18, 2000. 
# 
# The Initial Developer of the Original Code is Echidna. 
# Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
# All Rights Reserved. 
# 
# Contributor(s): 
# 

#
# Name of program.
#
PROGRAM   = test

#
# Program Modules.
#
LIBDEP = \
	menus.obj		\
	readmenu.obj	\
	ibmmouse.obj	\
	windows.obj		\
	hitareas.obj	\
	hndlevnt.obj	\
	keyboard.obj	\
	message.obj		\
	keyevent.obj	\
	filereq.obj		\
	edit.obj		\
	eui.obj			\
	floppy.obj		\
	lstgadg.obj		\
	elvtgadg.obj	\
	cmdgadg.obj		\
	gadgets.obj		\
	scic.obj		\
	hottext.obj		\

PDEP =	\
	$(PROGRAM).obj	\
	events.obj		\
	stubs.obj		\
	colorreq.obj	\
	colorseq.obj	\
	mwrtcrng.obj	\
	$(LIBDEP)		\

ODEP =	\

BLA = \
	$(ELIB)\echidna\memlib\memdbug.obj	\
	rm_tsinf.obj	\
	rmlst.obj		\
	stkerr.obj		\
	$(ELIB)\echidna\gfxlib\graphics.obj	\
	$(ELIB)\echidna\gfxlib\msup.obj		\
	$(ELIB)\echidna\gfxlib\fonts.obj	\
	$(ELIB)\echidna\gfxlib\dbuf.obj		\
	$(ELIB)\echidna\gfxlib\palette.obj	\
	$(ELIB)\echidna\gfxlib\mgfx.obj		\
	$(ELIB)\echidna\gfxlib\mdbuf.obj	\
	$(ELIB)\echidna\gfxlib\mpalette.obj	\

#
# Memory Model
#   s = Small
#   m = Medium
#   c = Compact
#   l = Large
#   h = Huge
MDL		= h
STARTUP	= c0$(MDL).obj

ELDEP = \
	echidna\xpak$(MDL).lib	\
	echidna\grafx$(MDL).lib	\
	echidna\timer$(MDL).lib	\
	echidna\misc$(MDL).lib	\
	echidna\mem$(MDL).lib	\
	echidna\lds$(MDL).lib	\

LDEP =	\
	c$(MDL).lib

#
# Name of linker file
#
LINKFILE  = linkfile.lnk

#
# 'C' compiler and global compiler flags.
#
CFLAGS    = $(CMN_CFLAGS) -m$(MDL)
CCOMPILER = $(CMN_CC) 

#
# Assembler and global assembler flags.
#
ASSEMBLER = $(CMN_ASM)
AFLAGS    = $(CMN_AFLAGS)

#
# Linker and global linker flags + libraries to like with.
#
LINKER    = $(CMN_LINK)
LFLAGS    = /c /x /v /m
LIBFILE   = libs.lnk

#
# Rule for Assembly modules.
#
.asm.obj:
	$(ASSEMBLER) $(AFLAGS) $*.asm

#
# Rule for 'C' modules.
#
.c.obj:
	$(CCOMPILER) $(CFLAGS) $*.c

#
# Rule for 'E' event modules.
.e.c:
	evntcomp $*.e

#
# Dependency for program.
#
$(PROGRAM).exe: $(PDEP) $(LIBDEP)
	makescan
	$(LINKER) $(LFLAGS) @$(LINKFILE), $(PROGRAM).EXE, , @$(LIBFILE)
	dir $(PROGRAM).EXE

#
# extra dependencies
#

colorseq.obj: colorseq.c colorseq.h
	$(CCOMPILER) $(CFLAGS) -N- $*.c

test.obj: test.c colorseq.h
	$(CCOMPILER) $(CFLAGS) -N- $*.c


	
