/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * DBUFAREA.H
 *
 * PROGRAMMER : Juan M. Alvarado
 *    VERSION : 00.000
 *    CREATED : 07/26/91
 *   MODIFIED : 07/27/94
 *       TABS : 04 08
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Defines for bit flags of AreaRecType flag field in dbuf routines.
 *
 * HISTORY
 *
*/
#ifndef DBUFAREA_H
#define DBUFAREA_H

#include <echidna/platform.h>
#include "switches.h"

/**************************** C O N S T A N T S ***************************/
#define STAMP_FLAG_BIT		0
#define PEEP_FLAG_BIT		1
#define SKIP_FLAG_BIT		2	

#define STAMP_FLAG_MASK	(1 << STAMP_FLAG_BIT)
#define PEEP_FLAG_MASK		(1 << PEEP_FLAG_BIT)
#define SKIP_FLAG_MASK		(1 << SKIP_FLAG_BIT)				

/* The skip flag means this area is no longer valid. Ignore it */

/******************************** T Y P E S *******************************/

typedef struct {
	WORD x; 
	WORD width; 
	WORD y; 
	WORD height;			
 	UWORD flags;	/* See constants defined above for meaning of bits. */ 
} AreaRecType;


/****************************** G L O B A L S *****************************/

extern AreaRecType	*SAdrawList, 
					*SAeraseList;
extern AreaRecType	*SAdrawPtr,
					*SAerasePtr; 


/******************************* M A C R O S ******************************/

#define SWAP_RESET_SALISTS() {	\
	AreaRecType *SAtempList;	\
	SAtempList	= SAdrawList;	\
	SAdrawList	= SAeraseList;	\
	SAeraseList	= SAtempList;	\
	SAerasePtr	= SAdrawPtr;	\
	SAdrawPtr	= SAdrawList;	\
						}

/****************** F U N C T I O N   P R O T O T Y P E S *****************/


#endif /* DBUFAREA_H */

