;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** ESHAPE.asm
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 03/06/90
;**   MODIFIED : 10/02/92
;**       TABS : 10 18 40 44
;**
;**	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**	Shape routines for EGA (originally written by John Reego)
;**	and modified by Gregg A. Tavares
;**
;** HISTORY
;**
;**




; DRAW_SPRITE (sprite #, Xw, Yw)  {SI, BX, CX}
;
;     sprite #  - address of sprite structure found in sprite_addr_table
;     Xw        - X position in world coordinates (w)
;     Yw        - Y position in world coordinates (w)

; sprite_addr_table
;        DD      sprite address 0
;        DD      sprite address 1
;        DD      sprite address 2
;        DD      sprite address .
;        DD      sprite address n
;
; sprite_structure
;       DW       x adjustment
;       DW       x length
;       DW       y adjustment
;       DW       y length
;       DB       SPRITE DATA  ...
;
; CS:EClipLeft	 - least    x pixel address of screen in world coordinates
; CS:EClipRight	 - greatest x pixel address of screen in world coordinates
; CS:EClipTop	 - least    y pixel address of screen in world coordinates
; CS:EClipBottom - greatest y pixel address of screen in world coordinates
;
; SPRx1 - least    x pixel address of sprite in world coordinates
; SPRx2 - greatest x pixel address of sprite in world coordinates
; SPRy1 - least    y pixel address of sprite in world coordinates
; SPRy2 - greatest y pixel address of sprite in world coordinates
;
; ABS x1, x2, y1, y2 should already be computed

	PROC CLIP_DATA NEAR

CLIP_LEFT    dw  ?
CLIP_RIGHT   dw  ?
CLIP_TOP     dw  ?
CLIP_BOTTOM  dw  ?
START_X      dw  ?
START_Y      dw  ?
CLIP_VALUE   dw  ?

X_LENGTH     dw  0                              ; fail RESTORE_BGND
REAL_X_LENGTH dw  ?
LINES_TO_GO  dw  ?
LINE_ADDR    dw  ?

NextABSx1    dw  ?
NextABSy1    dw  ?
Screen_Up    db  ?                      ; screen moving up
Screen_Down  db  ?                      ; screen moving down flag
Screen_Right db  ?
Screen_Left  db  ?

SPRx1        dw  ?
SPRx2        dw  ?
SPRy1        dw  ?
SPRy2        dw  ?

ds_save      dw  ?
si_save      dw  ?

DI_INC          dw ?                            ;#
X_LENGTH_T      dw ?                            ;#
LINES_TO_GO_T   dw ?                            ;#
SHFT_VAl        db ?

masklow		db ?	;GAT
	if 0
Label   sprite_addr_table DWORD
        dw      test_sprite1
        dw      Code
        dw      test_sprite2
        dw      Code
        DD 256 DUP (?)                  ; space for sprite address table

LABEL   test_sprite1 byte
        dw      0, 3, 0, 3      ; x_adj, x_len, y_adj, y_len
        db      0,0,0,0, 1,1,1,1, 0,0,0,0
        db      0,0,0,0, 3,3,3,3, 80h, 80h, 80h, 80h
        db      0,0,0,0, 1,1,1,1, 0,0,0,0
        db      0,0,0,0

LABEL   test_sprite2 byte
        dw      0,  4, 0, 15             ; x_adj, x_len, y_adj, y_len
        db      0,0,0,0, 00000000b, 00000111b, 00000111b, 00000000b
        db               00000000b, 11100000b, 11100000b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b

        db      0,0,0,0, 00000000b, 00001111b, 00001111b, 00000000b
        db               00000000b, 11110000b, 11110000b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b

        db      0,0,0,0, 00000000b, 00011111b, 00011111b, 00000000b
        db               00000000b, 11111000b, 11111000b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b

        db      0,0,0,0, 00000000b, 01111111b, 00011111b, 00000000b
        db               00000000b, 11111110b, 11111000b, 00000000b
        db               00000000b, 00000000b, 00111000b, 00000000b

        db      0,0,0,0, 00000000b, 11111111b, 00011111b, 00000000b
        db               00000000b, 11111111b, 11111000b, 00000000b
        db               00000000b, 00000000b, 00111100b, 00000000b

        db      0,0,0,0, 00000000b, 11111111b, 00001111b, 00000000b
        db               00000000b, 11111111b, 11110000b, 00000000b
        db               00000000b, 00000000b, 01111100b, 00000000b

        db      0,0,0,0, 00000000b, 01111111b, 00000011b, 00000000b
        db               00000000b, 11111111b, 11000000b, 00000000b
        db               00000000b, 00000000b, 01111000b, 00000000b

        db      0,0,0,0, 00000000b, 00111111b, 00000000b, 00000000b
        db               00000000b, 11111110b, 00000000b, 00000000b
        db               00000000b, 00000000b, 11110000b, 00000000b

        db      0,0,0,0, 00000000b, 00111011b, 00000000b, 00000000b
        db               00000000b, 11101110b, 00000000b, 00000000b
        db               00000000b, 00000000b, 11100000b, 00000000b

        db      0,0,0,0, 00000000b, 00111000b, 00000000b, 00000001b
        db               00000000b, 00001110b, 00000000b, 01000000b
        db               00000000b, 00000000b, 10000000b, 00000000b

        db      0,0,0,0, 00000000b, 00100000b, 00001111b, 00001111b
        db               00000000b, 00001110b, 00000001b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b

        db      0,0,0,0, 00000010b, 00000010b, 01111110b, 01111100b
        db               00000000b, 00000100b, 00000110b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b

        db      0,0,0,0, 01000100b, 01000100b, 01111100b, 00111000b
        db               00000000b, 00001010b, 00001110b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b

        db      0,0,0,0, 00101000b, 00101000b, 00111000b, 00010000b
        db               00000000b, 00000000b, 00001000b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b

        db      0,0,0,0, 00010000b, 00010000b, 00010000b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b
        db               00000000b, 00000000b, 00000000b, 00000000b

        db      0,0,0,0
	endif

LABEL   CASE_TABLE  WORD
        dw      DRAW_BEGIN      ; 0
        dw      CL_BEGIN        ; 1
        dw      CR_BEGIN        ; 2
        dw      CT_BEGIN        ; 3
        dw      CTL_BEGIN       ; 4
        dw      CTR_BEGIN       ; 5
        dw      DRAW_BEGIN      ; 6
        dw      CL_BEGIN        ; 7
        dw      CR_BEGIN        ; 8

which_case   db  ?

ENDP CLIP_DATA

;****************************** Quick_Sprite *******************************
; Quick_Sprite - draw byte on EGA screen. Drop in replacement
; for John Reego's Quick_Sprite. By Daniel Chang, 10/04/89.
;
; INPUT:
; DS:SI - source data
; ES:DI - screen
; DX - 03xxh

	PROC Quick_SpriteX NEAR
fast_out:
	inc	di
	ret

	PROC Quick_Sprite NEAR

	cld
	lodsw                   	; Load in Bit Planes 01        12
	mov	bx, ax            	;                               2
	lodsw                   	; Load in Bit Planes 23        12
	mov	bp, ax            	;                               2
	lodsb	                	;GAT ; load mask
	mov	[cs:masklow],al 	;GAT ; save mask
	lodsw                   	; LOAD in Bit Planes 01-2      12
	xchg	bl, ah            	;                               3
                                 	;
	mov	cl, [cs:Shft_val] 	;                              10
	shl	ax, cl            	;                              20
	shl	bx, cl            	;                              20

	mov	bl, ah          	;DCC
	xchg	bx, bp          	;DCC

	lodsw                   	; Load in Bit Planes 23-2      12
	xchg	bl, ah            	;                               3
	shl	ax, cl            	;                              20
	shl	bx, cl            	;                              20

	mov	bl, ah	;DCC

	lodsb		;GAT ; load mask
	sub	si,5	;GAT
	mov	ah,[cs:masklow]	;GAT ; get mask
	shl	ax,cl	;GAT
	or	ah,ah	;GAT
	jz	fast_out	;DCC

	mov	al, ah	;GAT
	mov	dl, 0cfh	;DCC ;Set the Bit Mask
	out	dx, al	;DCC

	mov	ax, bp	;DCC
	mov	cl, al	;GAT
	mov	al, [es:di]	;DCC ;Read the EGA Latches

	mov	al, 1	;DCC ;Set EGA to Bit Plane 0
	mov	dl, ch	;DCC
	out	dx, al	;DCC

	mov	[es:di], cl	;DCC ;Write Plane 0
	shl	al, 1	;DCC ;Set Bit Plane 1
	out	dx, al	;DCC

	mov	[es:di], ah	;DCC ;Write Plane 1
	shl	al, 1	;DCC ;Set Bit Plane 2
	out	dx, al	;DCC

	mov	[es:di], bl	;DCC ;Write Plane 2
	shl	al, 1	;DCC ;Set Bit Plane 3
	out	dx, al	;DCC

	mov	al, bh	;DCC
	stosb		;DCC ;Write Plane 3

	ret 		;DCC
	ENDP
	ENDP

;****************************** ResetGraphics ******************************
	PROC fResetGraphics NEAR

	mov	dx,03C4h 	; write to all planes
	mov	ax,0F02h
	out	dx,ax

	mov	dx,03CEh 	; remove S/R
	mov	ax,0001h
	out	dx,ax

	mov	ax,0FF08h	; set bit-mask for all bits
	out	dx,ax

	mov	ax,0005h 	; read mode = 0
	out	dx,ax

	mov	ax,0003h 	; "stored" data on writes
	out	dx,ax

	mov	ax,0004h 	; read from plane 0
	out	dx,ax

	ret
	ENDP

;******************************* DrawSprite1 *******************************
	PROC DRAW_SPRITEx NEAR
@@off_screen:
        sub   bx, bx
        ret
@@early_exit:
        sub   bx, bx 	; set X_LENGTH to zero
        ret
DRAW_SPRITE1:
        cld
        mov   ax, cs
        mov   es, ax
;--------------------------------------------------------------------------
;       COMPUTE EDGES OF SPRITE IN WORLD COORDINATES
;
;          INPUT:  bx = x_addr of sprite in world coordinates
;                  cx = y_addr of sprite in world coordinates
;                  si = sprite number
;--------------------------------------------------------------------------
        mov   dl, bl              	; save # of bits to shift
        and   bl, 011111000b      	; get rid of bits we will shift
        LODSW                     	; compute SPRx1
        add   bx, ax              	;
        mov   [cs:SPRx1], bx      	;
;--
        and   dl, 0111b           	;
        mov   dh, 8               	;
        sub   dh, dl              	;
        mov   [cs:shft_val], dh   	;
;--
        LODSW                     	; compute SPRx2
        mov   [cs:X_LENGTH], ax   	; save X_LENGTH
        shl   ax, 1
        shl   ax, 1
        shl   ax, 1
        add   bx, ax              	;
        dec   bx                  	;
        mov   [cs:SPRx2], bx      	;
        LODSW                     	; compute SPRy1
        add   cx, ax              	;
        mov   [cs:SPRy1], cx      	;
        LODSW                     	; compute SPRy2
        mov   [cs:LINES_TO_GO], ax	; save Y_LENGTH
        add   cx, ax              	;
        dec   cx                  	;
        mov   [cs:SPRy2], cx      	;
;--------------------------------------------------------------------------
;       IS ANY PART OF THE SPRITE ON THE VIEWING SCREEN ?
;--------------------------------------------------------------------------
        mov   [cs:ds_save], ds   	; save ds {sprite_data}
        mov   ax, cs             	; restore ds
        mov   ds, ax             	;
        mov   [si_save], si      	; save si {sprite data}

        mov   [which_case], 0    	; assume no clipping
        mov   ax, [SPRy1]        	; SPRITE BELOW SCREEN ?
        cmp   ax, [CS:EClipBottom]        	;
        jg    @@earlyexit          	;
        mov   ax, [SPRy2]        	; SPRITE ABOVE SCREEN ?
        cmp   ax, [CS:EClipTop]        	;
        jl    @@earlyexit          	;
        mov   ax, [SPRx1]        	; SPRITE RIGHT OF SCREEN ?
        cmp   ax, [CS:EClipRight]        	;
        jg    @@earlyexit          	;
        mov   ax, [SPRx2]        	; SPRITE LEFT OF SCREEN ?
        cmp   ax, [CS:EClipLeft]        	;
        jl    @@earlyexit          	;
        jmp   SHORT @@keep_trucking
@@earlyexit:
        jmp   @@early_exit
@@offscrn:
        jmp   @@off_screen
@@keep_trucking:

;--------------------------------------------------------------------------
;       COMPUTE CLIPPING COMPONENTS (IF ANY)
;--------------------------------------------------------------------------
        sub   ax, ax             		;
        lea   di, [CLIP_LEFT]    		;
        mov   cx, 6              		;
        REP   STOSW              		; zero out clip variables

	mov   ax,[SPRx1]	; clip the left edge.
        shr   ax, 1              		; 
        shr   ax, 1              		;
        shr   ax, 1              		;
	mov   [START_X],ax

        mov   ax, [CS:EClipLeft]        		; clip the left edge ?
        sub   ax, [SPRx1]        		;
        js    @@do_right          		;
        jz    @@not_neg_b          		;
        shr   ax, 1              		; ^^
        shr   ax, 1              		; ^^
        shr   ax, 1              		; ^^
        mov   [CLIP_LEFT], ax    		;
	mov   ax,[CS:EClipLeft]
        shr   ax, 1              		; 
        shr   ax, 1              		;
        shr   ax, 1              		;
	mov   [START_X],ax
        add   [which_case], 1    		;
        jmp SHORT   @@not_neg_b    		;

@@do_right:
        mov   ax, [SPRx2]        		; clip the right edge ?
        sub   ax, [CS:EClipRight]        		;
        js    @@not_neg_b          		;
        je    @@not_neg_b          		;

        shr   ax, 1              		; ^^
        shr   ax, 1              		; ^^
        shr   ax, 1              		; ^^
        mov   [CLIP_RIGHT], ax   		;
        add   [which_case], 2    		;

@@not_neg_b:                       		;
	mov   ax, [SPRy1]	; clip the top.
	mov   [START_Y],ax
	neg   ax
	add   ax, [CS:EClipTop]
        js    @@do_bottom          		;
        jz    @@not_neg_d
        mov   [CLIP_TOP], ax     		;
	mov   ax,[CS:EClipTop]
	mov   [START_Y],ax
        add   [which_case], 3    		;
        jmp SHORT @@not_neg_d    		;

@@do_bottom:

        mov   ax, [SPRy2]        		; clip the bottom ?
        sub   ax, [CS:EClipBottom]        		;
        js    @@not_neg_d          		;
        jz    @@not_neg_d          		;
        mov   [CLIP_BOTTOM], ax  		;
        add   [which_case], 6    		;
@@not_neg_d:                       		;

;--------------------------------------------------------------------------
;     CLIPPING ALGORITHM    ah must = 0
;                           bx = pixels remaining to DRAW / CLIP
; CASE:                     cx = # data bits DATA / TRANS
;     4--3--5               dx = LINES_TO_GO
;     1  0  2               bp = LINE_ADDR  (where DRAW starts for each line)
;     7--6--8               ds:si --> sprite data
;                           es:di --> screen address in DRAW modes
;--------------------------------------------------------------------------

        mov   ax, [X_LENGTH]     	;
        mov   [REAL_X_LENGTH], ax	;
        sub   ax, [CLIP_RIGHT]   	;
        sub   ax, [CLIP_LEFT]    	;
        mov   [X_LENGTH], ax     	;

        mov   ax, [LINES_TO_GO]  	;
        sub   ax, [CLIP_TOP]     	;
        sub   ax, [CLIP_BOTTOM]  	;
        mov   [LINES_TO_GO], ax  	;
        mov   bx, 1              	; set not entirely clipped flag
        ret

DRAW_SPRITE2:
        cld
        mov   bx, [START_Y]      	;
        shl   bx, 1              	;
        mov   bx, [LINEST+bx]    	; multiply by 320
        add   bx, [START_X]      	;
        mov   ax, 0              	; GAT!

        mov   [LINE_ADDR], bx    	;

        call  fResetGraphics     	;#
        mov   dx, 3ceh           	;# Point to Bit MAsk
        mov   al, 8              	;#
        out   dx, al             	;#
        mov   dl, 0c4h           	;# Point to Map Mask
        mov   al, 2              	;#
        out   dx, al             	;#

        mov   dx, [LINES_TO_GO]  	; dx = LINES_TO_GO
        mov   ax, [CS:EGrSeg]    	; es = a000h
        mov   es, ax             	;
        mov   si, [si_save]      	; restore si --> sprite data

        mov   ax, [REAL_X_LENGTH]	; ^^
        sub   ax, [X_LENGTH]     	; ^^
        mov   bx, ax	;GAT
        shl   ax, 1              	; ^^
        shl   ax, 1              	; ^^
        add   ax, bx     	;GAT
        mov   [CLIP_VALUE], ax   	; ^^

        cmp   [shft_val],8	;GAT
        je    @@noshifting
        mov   bl, [which_case]   	;
        sub   bh, bh             	;
        shl   bx, 1              	;
        jmp   [case_table+bx]    	;

@@noshifting:
        add   si,5	;GAT
        mov   bl, [which_case]   	;
        sub   bh, bh             	;
        shl   bx, 1              	;
        jmp   [case_tableb+bx]    	;

;--------------------------------------------------------------------------
;    ENTRY POINTS
;--------------------------------------------------------------------------

CTL_BEGIN:                        	; CASES (1, 7)
        add   si, [CLIP_VALUE]
CTR_BEGIN:                        	; CASES (2, 8)
CT_BEGIN:                         	; CASES (0, 6)
        mov   ax, [CLIP_TOP]
        mov   bx, [REAL_X_LENGTH]
        mul   bl
        mov   bx, ax	;GAT
        shl   ax, 1
        shl   ax, 1
        add   ax, bx	;GAT
        add   si, ax

        jmp   SHORT DRAW_BEGIN
; ---------------------------------------------------------------------



CL_BEGIN:                          	; CASES (1, 7)
        add   si, [CLIP_VALUE]
CR_BEGIN:                          	; CASES (2, 8)
        jmp   SHORT DRAW_BEGIN

;-------------------------------------------------------------------
;       DRAW SPRITE WITHOUT CLIPPING
;-------------------------------------------------------------------

DRAW_BEGIN:                        	; CASES (0, 6)
        mov   di, [LINE_ADDR]      	;#
        mov   ax, [LINES_TO_GO]    	;#
        mov   [LINES_TO_GO_T], ax  	;#
        mov   ax, 40               	;#
        sub   ax, [X_LENGTH]       	;#
        mov   [DI_INC], ax         	;#
        mov   ds, [ds_save]        	;#
        mov   ch, 0c5h             	;#
        mov   dh, 03h              	;#

@@QS_LOOP1:                          	;#
        mov ax, [cs:x_LENGTH]      	;#
        mov [cs:X_LENGTH_T], ax    	;#

@@QS_LOOP2:                          	;#
;************************************  *************************************
	lodsw                   	; Load in Bit Planes 01        12
	mov	bx, ax            	;                               2
	lodsw                   	; Load in Bit Planes 23        12
	mov	bp, ax            	;                               2
	lodsb	                	;GAT ; load mask
	mov	[cs:masklow],al 	;GAT ; save mask
	lodsw                   	; LOAD in Bit Planes 01-2      12
	xchg	bl, ah            	;                               3
                                 	;
	mov	cl, [cs:Shft_val] 	;                              10
	shl	ax, cl            	;                              20
	shl	bx, cl            	;                              20

	mov	bl, ah          	;DCC
	xchg	bx, bp          	;DCC

	lodsw                   	; Load in Bit Planes 23-2      12
	xchg	bl, ah            	;                               3
	shl	ax, cl            	;                              20
	shl	bx, cl            	;                              20

	mov	bl, ah	;DCC

	lodsb		;GAT ; load mask
	sub	si,5	;GAT
	mov	ah,[cs:masklow]	;GAT ; get mask
	shl	ax,cl	;GAT

	mov	al, ah	;GAT
	mov	dl, 0cfh	;DCC ;Set the Bit Mask
	out	dx, al	;DCC

	mov	ax, bp	;DCC
	mov	cl, al	;GAT
	mov	al, [es:di]	;DCC ;Read the EGA Latches

	mov	al, 1	;DCC ;Set EGA to Bit Plane 0
	mov	dl, ch	;DCC
	out	dx, al	;DCC

	mov	[es:di], cl	;DCC ;Write Plane 0
	shl	al, 1	;DCC ;Set Bit Plane 1
	out	dx, al	;DCC

	mov	[es:di], ah	;DCC ;Write Plane 1
	shl	al, 1	;DCC ;Set Bit Plane 2
	out	dx, al	;DCC

	mov	[es:di], bl	;DCC ;Write Plane 2
	shl	al, 1	;DCC ;Set Bit Plane 3
	out	dx, al	;DCC

	mov	al, bh	;DCC
	stosb		;DCC ;Write Plane 3
;************************************  *************************************
        dec   [cs:X_LENGTH_T]      	;#
        jnz   @@QS_LOOP2             	;#
        dec   [cs:LINES_TO_GO_T]   	;#
        jz    @@ALL_DONE             	;#
        add   si, [cs:CLIP_VALUE]  	;#
        add   di, [cs:DI_INC]      	;#
        jmp   short @@QS_LOOP1       	;#

@@ALL_DONE:                          	;
;        mov   ax, cs               	;
;        mov   ds, ax               	;
;        mov   ax, [START_X]
;        shl   ax, 1
;        shl   ax, 1
;        shl   ax, 1
;        add   ax, [CS:EClipLeft]
;        mov   bx, [X_LENGTH]
;        mov   cx, [START_Y]
;        add   cx, [CS:EClipTop]
;        mov   dx, [LINES_TO_GO]
        ret                        	;

ENDP DRAW_SPRITEx

;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************
;************************************  *************************************


LABEL   CASE_TABLEb  WORD
        dw      DRAW_BEGINb      ; 0
        dw      CL_BEGINb        ; 1
        dw      CR_BEGINb        ; 2
        dw      CT_BEGINb        ; 3
        dw      CTL_BEGINb       ; 4
        dw      CTR_BEGINb       ; 5
        dw      DRAW_BEGINb      ; 6
        dw      CL_BEGINb        ; 7
        dw      CR_BEGINb        ; 8

	PROC DRAW_SPRITExb NEAR

;--------------------------------------------------------------------------
;    ENTRY POINTS
;--------------------------------------------------------------------------

CTL_BEGINb:                        	; CASES (1, 7)
        add   si, [CLIP_VALUE]
CTR_BEGINb:                        	; CASES (2, 8)
CT_BEGINb:                         	; CASES (0, 6)
        mov   ax, [CLIP_TOP]
        mov   bx, [REAL_X_LENGTH]
        mul   bl
        mov   bx, ax	;GAT
        shl   ax, 1
        shl   ax, 1
        add   ax, bx	;GAT
        add   si, ax

        jmp   SHORT DRAW_BEGINb
; ---------------------------------------------------------------------



CL_BEGINb:                          	; CASES (1, 7)
        add   si, [CLIP_VALUE]
CR_BEGINb:                          	; CASES (2, 8)
        jmp   SHORT DRAW_BEGINb

;-------------------------------------------------------------------
;       DRAW SPRITE WITHOUT CLIPPING
;-------------------------------------------------------------------

DRAW_BEGINb:                        	; CASES (0, 6)
        mov   di, [LINE_ADDR]      	;#
        mov   ax, [LINES_TO_GO]    	;#
        mov   [LINES_TO_GO_T], ax  	;#
        mov   ax, 40               	;#
        sub   ax, [X_LENGTH]       	;#
        mov   [DI_INC], ax         	;#
        mov   ds, [ds_save]        	;#
        mov   ch, 0c5h             	;#
        mov   dh, 03h              	;#

@@QS_LOOP1:                          	;#
        mov ax, [cs:x_LENGTH]      	;#
        mov [cs:X_LENGTH_T], ax    	;#

@@QS_LOOP2:                          	;#
;************************************  *************************************
	lodsw                   	; Load in Bit Planes 01        12
	mov	bp, ax            	;                               2
	lodsw                   	; Load in Bit Planes 23        12
	mov	bx, ax            	;                               2
	lodsb	                	;GAT ; load mask

	mov	dl, 0cfh	;DCC ;Set the Bit Mask
	out	dx, al	;DCC

	mov	ax, bp	;DCC
	mov	cl, al	;GAT
	mov	al, [es:di]	;DCC ;Read the EGA Latches

	mov	al, 1	;DCC ;Set EGA to Bit Plane 0
	mov	dl, ch	;DCC
	out	dx, al	;DCC

	mov	[es:di], cl	;DCC ;Write Plane 0
	shl	al, 1	;DCC ;Set Bit Plane 1
	out	dx, al	;DCC

	mov	[es:di], ah	;DCC ;Write Plane 1
	shl	al, 1	;DCC ;Set Bit Plane 2
	out	dx, al	;DCC

	mov	[es:di], bl	;DCC ;Write Plane 2
	shl	al, 1	;DCC ;Set Bit Plane 3
	out	dx, al	;DCC

	mov	al, bh	;DCC
	stosb		;DCC ;Write Plane 3
;************************************  *************************************
        dec   [cs:X_LENGTH_T]      	;#
        jnz   @@QS_LOOP2             	;#
        dec   [cs:LINES_TO_GO_T]   	;#
        jz    @@ALL_DONE             	;#
        add   si, [cs:CLIP_VALUE]  	;#
        add   di, [cs:DI_INC]      	;#
        jmp   short @@QS_LOOP1       	;#

@@ALL_DONE:                          	;
;        mov   ax, cs               	;
;        mov   ds, ax               	;
;        mov   ax, [START_X]
;        shl   ax, 1
;        shl   ax, 1
;        shl   ax, 1
;        add   ax, [CS:EClipLeft]
;        mov   bx, [X_LENGTH]
;        mov   cx, [START_Y]
;        add   cx, [CS:EClipTop]
;        mov   dx, [LINES_TO_GO]
        ret                        	;

ENDP DRAW_SPRITExb

;=====================================================================
;**
;** EGA_DrawShape
;**
;** PURPOSE
;**	Draw a Shape on an EGA screen.
;**
;** INPUT
;**	DS:SI	far pointer to Shape data.
;**	BX	xpos.
;**	CX	ypos.
;**
;** REGISTER USED
;**	All of them
;**
;** EFFECTS
;**	??
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	May have problems if Shape Data crosses the end of the
;**	specified SEGMENT, so, NORMALIZE DS:SI so that SI is a
;**	small value (0-15).
;**
;** HISTORY
;**	
;**

	MPROC	EGA_DrawShape

	CALL	DRAW_SPRITE1
	or	bx,bx
	jz	@@cliped
	CALL	DRAW_SPRITE2
@@cliped:
	ret
	
	ENDP

;=====================================================================
;**
;** _EGA_DrawShape
;**
;** PURPOSE
;**	C glue for DrawShape.  Draws a shape on an EGA screen.
;**
;** INPUT
;**	C style parms: DrawShape (far *Shape, int x, int y)
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	May have problems if Shape Data crosses the end of the
;**	specified SEGMENT, so, NORMALIZE DS:SI so that SI is a
;**	small value (0-15).
;**
;** HISTORY
;**	
;**

	MPROC _EGA_DrawShape
	ARG	SpOff:WORD,SpSeg:WORD,XPOS:WORD,YPOS:WORD

	push	bp
	mov	bp,sp

	push	ds
	push	si
	push	di

	mov	ds,[SpSeg]
	mov	si,[SpOff]
	mov	bx,[XPOS]
	mov	cx,[YPOS]
;	add	si,8  	;Add GSHAPESIZE. Defined in graphics.h
	add	si,8+2	;Add GSHAPESIZE + 2 bytes for 
			; transparent color pattern fielrs.

	call	EGA_DrawShape

	pop	di
	pop	si
	pop	ds

	pop	bp
	ret
	ENDP

