;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** MGFXP.ASM
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 12/15/89
;**   MODIFIED : 10/14/93
;**       TABS : 09 15 40 44
;**
;**    	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**    Various Protected-mode Graphics Routines for MCGA mode.
;**    
;** HISTORY
;**	09/27/93 Monday (dcc) - created based on real mode MGFX.ASM.
;**
	.386

	IDEAL

	INCLUDE "GSWITCHS.inc"

; Prefix byte penalty for using 16-bit registers (AX, etc) vs 32-bit (EAX, etc).
; Return values (up to 32-bits) in EAX (p.143).
; Registers used in this order: EAX, EDX, EBX, ECX (p.131).
; RET must pop additional arguments off stack.
; Save all registers except "those used to pass & return values" (EAX, EBX, ECX & EDX) (p.137).
; If you refer to an EXTRN'ed variable, you must use the LARGE keyword.
 if 0 ;	THUS:
	push	ebp
	push	esi
	push	edi

	pop	edi
	pop	esi
	pop	ebp
 endif

;******************************** CONSTANTS ********************************

SCREEN_WIDTH	equ	320
SCREEN_HEIGHT	equ	200

;********************************* EXTERNS *********************************
	EXTRN MCGA_OpenGraphics_:PROC
	EXTRN MCGA_CloseGraphics_:PROC
	EXTRN MCGA_ConvertShape_:PROC
	EXTRN MCGA_FreeShape_:PROC
	EXTRN MCGA_DrawShapeNoTrans_:PROC
	EXTRN MCGA_DrawRect_:PROC
	EXTRN MCGA_GetGShapeLoadBuf_:PROC
	
     	if USE_GRAFX
	EXTRN MCGA_ClippedXORRect_:PROC
	EXTRN MCGA_ClippedCopyRect_:PROC
	EXTRN MCGA_ReallyClippedCopyRect_:PROC
	EXTRN MCGA_DrawShape_:PROC
	EXTRN	MCGA_SaveArea_:PROC
	EXTRN MCGA_RestoreArea_:PROC

	else
	EXTRN MCGA_UsePaletteN_:PROC
	EXTRN MCGA_FadeToPaletteN_:PROC
	EXTRN MCGA_UseColorCycleSet_:PROC   
	EXTRN MCGA_FadeToColorCycleSet_:PROC
	EXTRN MCGA_UsePaintBoxN_:PROC
	EXTRN MCGA_FadeToPaintBoxN_:PROC
	EXTRN MCGA_OpenPainter_:PROC
	EXTRN MCGA_ClosePainter_:PROC  
	endif

;********************************* SEGMENT *********************************

	MACRO	MPROC PNAME
		PROC PNAME
	ENDM

;	INCLUDE "GFXMDL.inc"
;	WSEG	MGFX_TEXT

;**************************** GLOBAL VARIABLES *****************************
	PUBLIC _MCGADataTable
	PUBLIC _MCGARoutineTable

	if USE_GRAFX
	PUBLIC _RemapTable
	PUBLIC _BeforeGraphicsFunc
	PUBLIC _AfterGraphicsFunc
	endif

;***************************** PUBLIC ROUTINES *****************************
	PUBLIC MCGA_ASMOpenGraphics_
	PUBLIC MCGA_ASMCloseGraphics_

;********************************* MACROS **********************************
	MACRO	BeforeGraphics

	if	USE_GRAFX
	call	RealBeforeGraphics_
	endif

	ENDM

	MACRO	AfterGraphics

	if	USE_GRAFX
	call	RealAfterGraphics_
	endif

	ENDM
;******************************** VARIABLES ********************************

	SEGMENT _DATA DWORD PUBLIC USE32 'DATA'

MClipLeft	 dd 0
MClipTop	 dd 0
MClipWidth	 dd SCREEN_WIDTH
MClipHeight	 dd SCREEN_HEIGHT
MClipRight	 dd SCREEN_WIDTH-1
MClipBottom	 dd 199
MGrDraw		 DD ?	; offset of buffer to draw into
MPenColor	 DB ?
MPaperColor	 DB ?
MWorkBuffer	 DD 0
MBackBuffer	 DD 0
MDisplayBuffer DD 0A0000h

	LABEL	_BeforeGraphicsFunc DWORD
	DD	0
	LABEL	_AfterGraphicsFunc DWORD
	DD	0

	MACRO Rptr Routine

	DD	OFFSET Routine

	ENDM

_MCGADataTable:
	RPtr	MClipLeft
	RPtr	MClipTop 
	RPtr	MClipWidth
	RPtr	MClipHeight
	RPtr	MClipRight 
	RPtr	MClipBottom
	RPtr	MPenColor
	RPtr	MPaperColor
	RPtr	MGrDraw
	RPtr	MWorkBuffer
	RPtr	MBackBuffer
	RPtr	MDisplayBuffer
	RPtr	0
	RPtr	0

_MCGARoutineTable:
	Rptr	MCGA_OpenGraphics_
	Rptr	MCGA_CloseGraphics_
	Rptr	MCGA_DrawPixel_
	Rptr	MCGA_DrawRect_
	Rptr	MCGA_ClearScreen_
	Rptr	MCGA_DrawShape_
	Rptr	MCGA_Restore_
	Rptr	MCGA_UnRestore_
	Rptr	MCGA_ShowRect_
	Rptr	MCGA_ConvertShape_
	Rptr	MCGA_FreeShape_
	Rptr	MCGA_DrawShapeNoTrans_
	Rptr	MCGA_GetGShapeLoadBuf_
	if USE_GRAFX
	else
	Rptr	MCGA_UsePaletteN_
	Rptr	MCGA_FadeToPaletteN_
	Rptr	MCGA_UseColorCycleSet_
	Rptr	MCGA_FadeToColorCycleSet_
	Rptr	MCGA_UsePaintBoxN_
	Rptr	MCGA_FadeToPaintBoxN_
	Rptr	MCGA_OpenPainter_
	Rptr	MCGA_ClosePainter_
	endif
	if USE_GRAFX
	Rptr	MCGA_ClippedXORRect_
	Rptr	MCGA_ClippedCopyRect_
	Rptr	MCGA_ReallyClippedCopyRect_
	Rptr	MCGA_SaveArea_
	Rptr	MCGA_RestoreArea_
	endif
	Rptr	0

	LABEL LineSt  WORD	; Lookup table for line start adresses
i 	=	0
	REPT	SCREEN_HEIGHT	
	DW	i*SCREEN_WIDTH
i	=	i + 1
	ENDM

	if USE_GRAFX
	LABEL _RemapTable BYTE	; RemapTable for colors.
i	=	0
	REPT	256
	DB	i
i	=	i + 1
	ENDM
	endif

	ENDS	_DATA

	GROUP	DGROUP _DATA

	SEGMENT _TEXT DWORD PUBLIC USE32 'CODE'

	ASSUME cs:_TEXT
	ASSUME ds:DGROUP

;=====================================================================
;**
;** MCGA_ASMCloseGraphics_
;**
;** PURPOSE
;**	Free MCGA resources and return to text mode.
;**
;** INPUT
;**	NONE
;**
;** REGISTERS USED
;**	AX, BX, ES
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	MPROC MCGA_ASMCloseGraphics_
	MPROC MCGA_ASMCloseGraphics_

	mov	ax, 03h	; Return to Text mode
	int	10h

@@no_obuf:
	sub	eax, eax	; Return 0 for OpenGraphics Failure.
	ret
	ENDP
	ENDP

;=====================================================================
;**
;** MCGA_ASMOpenGraphics
;** MCGA_ASMOpenGraphics_
;**
;** PURPOSE
;**	Initialize MCGA Graphics Routines.
;**
;** INPUT
;**	NONE
;**
;** REGISTERS USED
;**	AX, BX, ES
;**
;** RETURN VALUE
;**	AX = 0  failed
;**	   = !0 success
;**
;** LIMITS/BUGS
;**		
;**
;** HISTORY
;**		
;**

	MPROC MCGA_ASMOpenGraphics_
	MPROC MCGA_ASMOpenGraphics

	mov	ax, 013h	; Start MCGA mode.
	int	10h

	ret
	ENDP
	ENDP


	if USE_GRAFX
;=====================================================================
;**
;** RealBeforeGraphics_
;**
;** PURPOSE
;**	Allow something to always be done before screen memory is
;**	modified.
;**
;** INPUT
;**	NONE.
;**
;** REGISTER USED
;**	NONE.
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	PUBLIC RealBeforeGraphics_
	MPROC  RealBeforeGraphics_

	push	ebp
	push	eax
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi

	cmp	[DWORD ptr _BeforeGraphicsFunc],0
	jz	@@skip
	call	[_BeforeGraphicsFunc]
@@skip:

	pop	edi
	pop	esi
	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	pop	ebp
	ret

	ENDP


;=====================================================================
;**
;** RealAfterGraphics_
;**
;** PURPOSE
;**	Allow something to always be done After screen memory is
;**	modified.
;**
;** INPUT
;**	NONE.
;**
;** REGISTER USED
;**	NONE.
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	PUBLIC RealAfterGraphics_
	MPROC  RealAfterGraphics_

	push	ebp
	push	eax
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi


	cmp	[DWORD ptr _AfterGraphicsFunc],0
	jz	@@skip
	call	[_AfterGraphicsFunc]
@@skip:

	pop	edi
	pop	esi
	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	pop	ebp
	ret

	ENDP
	endif


 if 0
;=====================================================================
;**
;** MCGA_DrawPixel
;**
;** PURPOSE
;**	Draw one Pixel on the current work page.
;**
;** INPUT
;**	EAX       : DWORD xpos
;**	EBX       : DWORD ypos
;**	MPenColor : UBYTE color
;**
;** REGISTERS USED
;**	EAX, EBX
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	MPROC MCGA_DrawPixel

	push	edi

	BeforeGraphics

	shl	ebx,1
	sub	edi,edi
	mov	di,[LineSt+EBX]	; Get Starting address of y row
	add	edi,eax	; add x column.

	add	edi,[MGrDraw]	; Add base address of current page.

	if	USE_GRAFX
	sub	ebx,ebx
	mov	bl,[MPenColor]	; Get Pen Color.
	mov	al,[_RemapTable+ebx]	; Look up thru RemapTable
	else
	mov	al,[MPenColor]
	inc	al
	endif

	mov	[edi],al
	AfterGraphics

	pop	edi
	ret

	ENDP
 endif


;=====================================================================
;**
;** MCGA_DrawPixel_
;**
;** USAGE
;**	void MCGA_DrawPixel(short xPos, short yPos);
;**
;** PURPOSE
;**	Draw one Pixel on the current work page.
;**
;** INPUT
;**	EAX	    : DWORD xPos
;**	EDX	    : DWORD yPos
;**	MPenColor : UBYTE color
;**
;** REGISTER USED
;**	NONE.
;**
;** RETURN VALUE
;**	NONE.
;**
;** LIMITS/BUGS
;**	No clipping performed.
;**
;** HISTORY
;**	09/29/93 Wednesday (dcc) - created (based on real-mode MCGA_DrawPixel)
;**
	MPROC MCGA_DrawPixel_

	push	ebp
	mov	ebp, esp

	push	edi

	BeforeGraphics

	shl	edx, 1	; yPos * 2 to index LineSt[]
	sub	edi, edi
	mov	di, [LineSt+EDX]	; Get Starting address of y row
	add	edi, eax	; add xPos

	add	edi, [MGrDraw]	; Add base address of current page.

	if	USE_GRAFX
	sub	edx, edx
	mov	dl, [MPenColor]	; Get Pen Color.
	mov	al, [_RemapTable+edx]	; Look up thru RemapTable[]
	else
	mov	al, [MPenColor]
	inc	al
	endif

	mov	[edi], al

	AfterGraphics

	pop	edi

	pop	ebp
	ret

	ENDP

;******************************** INCLUDES *********************************
	INCLUDE "MRESTORP.asm"
	INCLUDE "MRECTP.asm"
	INCLUDE "MCLEARP.asm"
	if USE_GRAFX
	else
	INCLUDE "MWRTCRNP.asm"
	INCLUDE "MSHAPEP.asm"
	endif

	ENDS
	END

